<template>
  <div class="rule unit-rule" :class="{error: isWrong}">
    <div class="rule-content unit-rule-content">
      <div class="unit-rule-content-symbol">
        <span>[{{rule.sym}}] <span><sup>+</sup></span></span>
      </div>
      <div class="unit-rule-content-equal">
        =
      </div>
      <div class="unit-rule-content-set">
        <span>{{ showSet }}</span>
      </div>
    </div>
    <div v-if="column.isEditable" class="rule-action" @click="removeUnitRule(rule)">
      <DeleteOutlineIcon :size="18"></DeleteOutlineIcon>
    </div>
  </div>
</template>

<script>
import {computed, inject} from "vue";
import DeleteOutlineIcon from "vue-material-design-icons/DeleteOutline.vue";

export default {
  name: "UnitRule",
  components: {
    DeleteOutlineIcon
  },
  props: ['rule', 'isWrong'],
  setup(props) {

    const column = inject('col')

    const showSet = computed(() => {
      let output = ""
      if (props.rule.set.length) {
        output += "{"
        props.rule.set.forEach(sym => {
          if(props.rule.set.indexOf(sym) < props.rule.set.length - 1) {
            output += `${sym}, `
          } else {
            output += sym
          }
        })
        output += "}"
      } else {
        output += "∅"
      }

      return output;
    })

    const removeUnitRule = (unitRule) => {
      const index = column.value.unitRulesWithSets.findIndex(rule => rule.sym === unitRule.sym);
      column.value.unitRulesWithSets.splice(index, 1);
    }

    return {
      showSet,
      removeUnitRule,
      column
    }
  }
}
</script>

<style scoped>

</style>